if RequiredScript == "lib/managers/menumanager" then
	if not _G.VoiceChanger then
		_G.VoiceChanger = _G.VoiceChanger or {}
		VoiceChanger._path = ModPath
		VoiceChanger._savepath = SavePath .. "voice_changer.txt"
		VoiceChanger._data = {
		sound = 1
		}
	end
	function VoiceChanger:Save()
		local file = io.open(self._savepath, "w+")
		if file then
			file:write(json.encode(self._data))
			file:close()
		end
	end
	function VoiceChanger:Load()
		local file = io.open(self._savepath, "r")
		if file then
			self._data = json.decode(file:read("*all"))
			file:close()
		end
	end
	local mpath = ModPath .. "loc/"
	Hooks:Add("LocalizationManagerPostInit", "LocalizationManager_Voice_Changer", function(loc)
		for _, filename in pairs( file.GetFiles(mpath) ) do
			local lang = filename:match("^(.*).txt$")
			if lang and Idstring(lang) and Idstring(lang):key() == SystemInfo:language():key() then
				loc:load_localization_file(mpath..filename)
				break
			else
				loc:load_localization_file(mpath.."english.txt")
				break
			end
		end
	end)
	local menu_id = "voice_changer_menu_id"
	Hooks:Add("MenuManagerSetupCustomMenus", "CustomMenus_VoiceChanger", function(menu_manager, nodes)
		MenuHelper:NewMenu(menu_id)
	end)
	Hooks:Add("MenuManagerPopulateCustomMenus", "PopulateCustomMenus_VoiceChanger", function(menu_manager, nodes)
		MenuCallbackHandler.voice_changer_cb = function(self, item)
			VoiceChanger._data.sound = item:value()
			VoiceChanger:Save()
		end
		VoiceChanger:Load()
		local items = {"Voice_Changer_vanilla",  -- Original
		"menu_" .. CriminalsManager.character_names()[3], -- Chains
		"menu_" .. CriminalsManager.character_names()[4], -- Houston
		"menu_" .. CriminalsManager.character_names()[2], -- Wolf
		"menu_" .. CriminalsManager.character_names()[1], -- Dallas
		"menu_" .. CriminalsManager.character_names()[6], -- Hoxton
		"menu_" .. CriminalsManager.character_names()[5], -- John Wick
		}
		for i = 7, CriminalsManager.get_num_characters() do
			table.insert(items, "menu_" .. CriminalsManager.character_names()[i]) -- should work with newly added heisters if they won't change the naming
		end
		
		MenuHelper:AddMultipleChoice({
			id = "voice_changer_id",
			title = "Voice_Changer_item",
			desc = "Voice_Changer_item_desc",
			callback = "voice_changer_cb",
			items = items,
			value = VoiceChanger._data.sound,
			menu_id = menu_id,
			priority = 6,
		})
	end)
	Hooks:Add("MenuManagerBuildCustomMenus", "BuildCustomMenus_VoiceChanger", function( menu_manager, nodes )
		nodes[menu_id] = MenuHelper:BuildMenu( menu_id )
		MenuHelper:AddMenuItem( MenuHelper:GetMenu("lua_mod_options_menu"), menu_id, "Voice_Changer_menu_entry", "Voice_Changer_menu_entry_desc" )
	end)
end
if RequiredScript == "lib/units/beings/player/playersound" then
	function PlayerSound:set_voice(voice)
		local Override_voice = VoiceChanger._data.sound - 1
		if Override_voice == 0 then
			self._unit:sound_source():set_switch("robber", voice)
		else
			self._unit:sound_source():set_switch("robber", "rb" .. Override_voice)
		end
	end
end
if RequiredScript == "lib/units/player_team/teamaisound" then
	function TeamAISound:set_voice(voice)
		local ss = self._unit:sound_source()
		local Override_voice = VoiceChanger._data.sound - 1
		if Override_voice == 0 then
			ss:set_switch("robber", voice)
			ss:set_switch("int_ext", "third")
		else
			ss:set_switch("robber", "rb" .. Override_voice)
			ss:set_switch("int_ext", "third")
		end
	end
end